## ceph 16.2.15

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)
# remove cmake/modules/FindPython* once 3.12 is required

project(ceph
  VERSION 16.2.15
  LANGUAGES CXX C ASM)

foreach(policy
    CMP0028
    CMP0046
    CMP0048
    CMP0051
    CMP0054
    CMP0056
    CMP0065
    CMP0074
    CMP0075
    CMP0093)
  if(POLICY ${policy})
    cmake_policy(SET ${policy} NEW)
  endif()
endforeach()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
  set(LINUX ON)
  FIND_PACKAGE(Threads)
elseif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
  set(FREEBSD ON)
  FIND_PACKAGE(Threads)
endif(CMAKE_SYSTEM_NAME MATCHES "Linux")

if(WIN32)
  # The Windows headers (e.g. coming from mingw or the Windows SDK) check
  # the targeted Windows version. The availability of certain functions and
  # structures will depend on it.
  set(WIN32_WINNT "0x0A00" CACHE STRING "Targeted Windows version.")
  # In order to avoid known winpthread issues, we're using the boost
  # shared mutex implementation.
  # https://github.com/msys2/MINGW-packages/issues/3319
  add_definitions(
    -D_WIN32_WINNT=${WIN32_WINNT}
    -DBOOST_THREAD_PROVIDES_GENERIC_SHARED_MUTEX_ON_WIN
    -DBOOST_THREAD_V2_SHARED_MUTEX
  )
  set(Boost_THREADAPI "win32")
endif()

if(MINGW)
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-allow-multiple-definition")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-allow-multiple-definition")

  # By default, cmake generates import libs for executables. The issue is that
  # for rados and rbd, the executable import lib overrides the library import lib.
  # For example, for rados.exe, it will end up generating a librados.dll.a import lib.
  # We're providing custom rules to disable import libs for executables.
  set(CMAKE_C_LINK_EXECUTABLE
    "<CMAKE_C_COMPILER> <FLAGS> <CMAKE_C_LINK_FLAGS> <LINK_FLAGS> <OBJECTS> -o <TARGET> ${CMAKE_GNULD_IMAGE_VERSION} <LINK_LIBRARIES>")
  set(CMAKE_CXX_LINK_EXECUTABLE
    "<CMAKE_CXX_COMPILER> <FLAGS> <CMAKE_CXX_LINK_FLAGS> <LINK_FLAGS> <OBJECTS> -o <TARGET> ${CMAKE_GNULD_IMAGE_VERSION} <LINK_LIBRARIES>")

  link_directories(${MINGW_LINK_DIRECTORIES})
endif()

option(WITH_CCACHE "Build with ccache.")
if(WITH_CCACHE)
  find_program(CCACHE_FOUND ccache)
  if(NOT CCACHE_FOUND)
    message(FATAL_ERROR "Can't find ccache. Is it installed?")
  endif()
  message(STATUS "Building with ccache: ${CCACHE_FOUND}, CCACHE_DIR=$ENV{CCACHE_DIR}")
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
  # ccache does not accelerate link (ld), but let it handle it. by passing it
  # along with cc to python's distutils, we are able to workaround
  # https://bugs.python.org/issue8027.
  set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
endif(WITH_CCACHE)

option(WITH_MANPAGE "Build man pages." ON)
if(WITH_MANPAGE)
  find_program(SPHINX_BUILD
    NAMES sphinx-build sphinx-build-3)
  if(NOT SPHINX_BUILD)
    message(FATAL_ERROR "Can't find sphinx-build.")
  endif(NOT SPHINX_BUILD)
endif(WITH_MANPAGE)

include_directories(
  ${PROJECT_BINARY_DIR}/src/include
  ${PROJECT_SOURCE_DIR}/src)

if(WIN32)
  include_directories(
    ${PROJECT_SOURCE_DIR}/src/include/win32)
  # Boost complains if winsock2.h (or windows.h) is included before asio.hpp.
  add_definitions(-include winsock_wrapper.h)
  # Boost is also defining some of the errno values, we'll have
  # to avoid mismatches.
  add_definitions(-include win32_errno.h)
endif()

if(FREEBSD)
  include_directories(SYSTEM /usr/local/include)
  link_directories(/usr/local/lib)
  list(APPEND CMAKE_REQUIRED_INCLUDES /usr/local/include)
endif(FREEBSD)


#put all the libs and binaries in one place
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

include(GNUInstallDirs)
include(CephChecks)

set(CEPH_MAN_DIR "share/man" CACHE STRING "Install location for man pages (relative to prefix).")

option(ENABLE_SHARED "build shared libraries" ON)
if(ENABLE_SHARED)
  set(CEPH_SHARED SHARED)
else(ENABLE_SHARED)
  set(CEPH_SHARED STATIC)
endif(ENABLE_SHARED)
set(CMAKE_POSITION_INDEPENDENT_CODE ${ENABLE_SHARED})

option(WITH_STATIC_LIBSTDCXX "Link against libstdc++ statically" OFF)
if(WITH_STATIC_LIBSTDCXX)
  if(NOT CMAKE_COMPILER_IS_GNUCXX)
    message(FATAL_ERROR "Please use GCC to enable WITH_STATIC_LIBSTDCXX")
  endif()
  set(static_linker_flags "-static-libstdc++ -static-libgcc")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${static_linker_flags}")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${static_linker_flags}")
  unset(static_linker_flags)
  set(GPERFTOOLS_USE_STATIC_LIBS TRUE)
endif()
include(CheckCxxAtomic)
if(NOT HAVE_CXX11_ATOMIC)
  set(CMAKE_CXX_STANDARD_LIBRARIES
    "${CMAKE_CXX_STANDARD_LIBRARIES} ${LIBATOMIC_LINK_FLAGS}")
endif()

option(WITH_RDMA "Enable RDMA in async messenger" ON)
if(WITH_RDMA)
  find_package(verbs REQUIRED)
  set(HAVE_VERBS ${VERBS_FOUND})
  find_package(rdmacm REQUIRED)
  set(HAVE_RDMACM ${RDMACM_FOUND})
  set(HAVE_RDMA TRUE)
endif()

find_package(Backtrace)

option(WITH_RBD "Enable RADOS Block Device related targets" ON)

if(LINUX)
  find_package(udev REQUIRED)
  set(HAVE_UDEV ${UDEV_FOUND})
  find_package(blkid REQUIRED)
  set(HAVE_BLKID ${BLKID_FOUND})
  find_package(keyutils REQUIRED)
  set(HAVE_KEYUTILS ${KEYUTILS_FOUND})
elseif(FREEBSD)
  set(HAVE_UDEV OFF)
  set(HAVE_LIBAIO OFF)
  set(HAVE_BLKID OFF)
  set(HAVE_KEYUTILS OFF)
else()
  set(HAVE_UDEV OFF)
  set(HAVE_BLKID OFF)
endif(LINUX)

option(WITH_OPENLDAP "OPENLDAP is here" ON)
if(WITH_OPENLDAP)
  find_package(OpenLdap REQUIRED)
  set(HAVE_OPENLDAP ${OPENLDAP_FOUND})
endif()

option(WITH_GSSAPI "GSSAPI/KRB5 is here" OFF)
if(WITH_GSSAPI)
  find_package(GSSApi REQUIRED)
  set(HAVE_GSSAPI ${GSSApi_FOUND})
endif()

option(WITH_FUSE "Fuse is here" ON)
if(WITH_FUSE)
  find_package(FUSE)
  set(HAVE_LIBFUSE ${FUSE_FOUND})
endif()

option(WITH_DOKAN "Dokan is here" OFF)

option(WITH_XFS "XFS is here" ON)
if(WITH_XFS)
  find_package(xfs)
  set(HAVE_LIBXFS ${XFS_FOUND})
endif()

option(WITH_ZFS "enable LibZFS if found" OFF)
if(WITH_ZFS)
  find_package(zfs)
  set(HAVE_LIBZFS ${ZFS_FOUND})
endif()

option(WITH_BLUESTORE "Bluestore OSD backend" ON)
if(WITH_BLUESTORE)
  if(LINUX)
    find_package(aio)
    set(HAVE_LIBAIO ${AIO_FOUND})
  elseif(FREEBSD)
    # POSIX AIO is integrated into FreeBSD kernel, and exposed by libc.
    set(HAVE_POSIXAIO ON)
  endif()
endif()

# libcryptsetup is only available on linux
if(WITH_RBD AND LINUX)
  find_package(libcryptsetup REQUIRED)
  set(HAVE_LIBCRYPTSETUP ${LIBCRYPTSETUP_FOUND})
  if(${LIBCRYPTSETUP_VERSION} VERSION_LESS 2.0.5)
    set(LIBCRYPTSETUP_LEGACY_DATA_ALIGNMENT TRUE)
  endif()
endif()

include(CMakeDependentOption)

CMAKE_DEPENDENT_OPTION(WITH_ZBD "Enable libzbd bluestore backend" OFF
  "WITH_BLUESTORE" OFF)
if(WITH_ZBD)
  find_package(zbd REQUIRED)
  set(HAVE_LIBZBD ${ZBD_FOUND})
endif()

CMAKE_DEPENDENT_OPTION(WITH_LIBURING "Enable io_uring bluestore backend" ON
  "WITH_BLUESTORE;HAVE_LIBAIO" OFF)
set(HAVE_LIBURING ${WITH_LIBURING})

CMAKE_DEPENDENT_OPTION(WITH_SYSTEM_LIBURING "Require and build with system liburing" OFF
  "HAVE_LIBAIO;WITH_BLUESTORE" OFF)

CMAKE_DEPENDENT_OPTION(WITH_BLUESTORE_PMEM "Enable PMDK libraries" OFF
  "WITH_BLUESTORE" OFF)

CMAKE_DEPENDENT_OPTION(WITH_RBD_MIGRATION_FORMAT_QCOW_V1
  "Enable librbd QCOW v1 migration format support" ON
  "WITH_RBD" OFF)

CMAKE_DEPENDENT_OPTION(WITH_RBD_RWL "Enable librbd persistent write back cache" OFF
  "WITH_RBD" OFF)

CMAKE_DEPENDENT_OPTION(WITH_RBD_SSD_CACHE "Enable librbd persistent write back cache for SSDs" OFF
    "WITH_RBD" OFF)

CMAKE_DEPENDENT_OPTION(WITH_SYSTEM_PMDK "Require and build with system PMDK" OFF
  "WITH_RBD_RWL OR WITH_BLUESTORE_PMEM" OFF)

if(WITH_BLUESTORE_PMEM)
  set(HAVE_BLUESTORE_PMEM ON)
endif()

CMAKE_DEPENDENT_OPTION(WITH_SPDK "Enable SPDK" OFF
  "CMAKE_SYSTEM_PROCESSOR MATCHES i386|i686|amd64|x86_64|AMD64|aarch64" OFF)
if(WITH_SPDK)
  if(NOT WITH_BLUESTORE)
    message(SEND_ERROR "Please enable WITH_BLUESTORE for using SPDK")
  endif()
  include(BuildSPDK)
  build_spdk()
  set(HAVE_SPDK TRUE)
endif(WITH_SPDK)

if(WITH_BLUESTORE)
  if(NOT AIO_FOUND AND NOT HAVE_POSIXAIO AND NOT WITH_SPDK AND NOT WITH_BLUESTORE_PMEM)
    message(SEND_ERROR "WITH_BLUESTORE is ON, "
      "but none of the bluestore backends is enabled. "
      "Please install libaio, or enable WITH_SPDK or WITH_BLUESTORE_PMEM (experimental)")
  endif()
endif()

option(WITH_BLUEFS "libbluefs library" OFF)

option(WITH_QATZIP "Enable QATZIP" OFF)
if(WITH_QATZIP)
  find_package(qatzip REQUIRED)
  set(HAVE_QATZIP ${QATZIP_FOUND})
endif(WITH_QATZIP)

# needs mds and? XXX
option(WITH_LIBCEPHFS "libcephfs client library" ON)

option(WITH_LIBCEPHSQLITE "libcephsqlite client library" ON)
if(WITH_LIBCEPHSQLITE)
  find_package(SQLite3 REQUIRED)
endif()

# key-value store
option(WITH_KVS "Key value store is here" ON)

option(WITH_KRBD "Enable Linux krbd support of 'rbd' utility" ON)

if(WITH_KRBD AND NOT WITH_RBD)
  message(FATAL_ERROR "Cannot have WITH_KRBD without WITH_RBD.")
endif()
if(LINUX)
  if(WITH_LIBCEPHFS OR WITH_KRBD)
    # keyutils is only used when talking to the Linux Kernel key store 
    find_package(keyutils REQUIRED)
    set(HAVE_KEYUTILS ${KEYUTILS_FOUND})
  endif()
endif()

option(WITH_LEVELDB "LevelDB is here" ON)
if(WITH_LEVELDB)
  if(LEVELDB_PREFIX)
    include_directories(SYSTEM ${LEVELDB_PREFIX}/include)
    link_directories(${LEVELDB_PREFIX}/lib)
  endif()
  find_package(leveldb REQUIRED)
  find_file(HAVE_LEVELDB_FILTER_POLICY leveldb/filter_policy.h PATHS ${LEVELDB_INCLUDE_DIR})
endif(WITH_LEVELDB)

find_package(snappy REQUIRED)

option(WITH_BROTLI "Brotli compression support" OFF)
if(WITH_BROTLI)
  set(HAVE_BROTLI TRUE)
endif()

option(WITH_LZ4 "LZ4 compression support" ON)
if(WITH_LZ4)
  find_package(LZ4 1.7 REQUIRED)
  set(HAVE_LZ4 ${LZ4_FOUND})
endif(WITH_LZ4)

option(WITH_CEPH_DEBUG_MUTEX "Use debug ceph::mutex with lockdep" OFF)

#if allocator is set on command line make sure it matches below strings
set(ALLOCATOR "" CACHE STRING
  "specify memory allocator to use. currently tcmalloc, tcmalloc_minimal, \
jemalloc, and libc is supported. if not specified, will try to find tcmalloc, \
and then jemalloc. If neither of then is found. use the one in libc.")
if(ALLOCATOR)
  if(${ALLOCATOR} MATCHES "tcmalloc(_minimal)?")
    find_package(gperftools REQUIRED)
    set(HAVE_LIBTCMALLOC ON)
  elseif(${ALLOCATOR} STREQUAL "jemalloc")
    find_package(JeMalloc REQUIRED)
    set(HAVE_JEMALLOC 1)
  elseif(NOT ALLOCATOR STREQUAL "libc")
    message(FATAL_ERROR "Unsupported allocator selected: ${ALLOCATOR}")
  endif()
else(ALLOCATOR)
  find_package(gperftools)
  set(HAVE_LIBTCMALLOC ${gperftools_FOUND})
  if(NOT gperftools_FOUND)
    find_package(JeMalloc)
  endif()
  if(gperftools_FOUND)
    set(ALLOCATOR tcmalloc)
  elseif(JeMalloc_FOUND)
    set(ALLOCATOR jemalloc)
  else()
    if(NOT FREEBSD)
      # FreeBSD already has jemalloc as its default allocator
      message(WARNING "tcmalloc and jemalloc not found, falling back to libc")
    endif()
    set(ALLOCATOR "libc")
  endif(gperftools_FOUND)
endif(ALLOCATOR)

# Mingw generates incorrect entry points when using "-pie".
if(WIN32 OR (HAVE_LIBTCMALLOC AND WITH_STATIC_LIBSTDCXX))
  set(EXE_LINKER_USE_PIE FALSE)
else()
  set(EXE_LINKER_USE_PIE ${ENABLE_SHARED})
endif()

if (HAVE_LIBTCMALLOC AND TCMALLOC_VERSION_STRING VERSION_LESS 2.6.2)
  set(LIBTCMALLOC_MISSING_ALIGNED_ALLOC ON)
endif()

find_package(CURL REQUIRED)
set(CMAKE_REQUIRED_INCLUDES ${CURL_INCLUDE_DIRS})
set(CMAKE_REQUIRED_LIBRARIES ${CURL_LIBRARIES})
CHECK_SYMBOL_EXISTS(curl_multi_wait curl/curl.h HAVE_CURL_MULTI_WAIT)

find_package(OpenSSL REQUIRED)
set(CRYPTO_LIBS OpenSSL::Crypto)

option(WITH_DPDK "Enable DPDK messaging" OFF)
if(WITH_DPDK)
  find_package(dpdk)
  if(NOT DPDK_FOUND)
    include(BuildDPDK)

=== src/tools/ceph-dencoder/CMakeLists.txt ===
## dencoder
set_source_files_properties(
  ceph_dencoder.cc
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_BINARY_DIR}/src/include/ceph_ver.h)

if(HAS_VTA)
  set_source_files_properties(ceph_dencoder.cc
    PROPERTIES COMPILE_FLAGS -fno-var-tracking-assignments)
endif()

set(dencoder_srcs
  ceph_dencoder.cc
  ../../include/uuid.cc
  ../../include/utime.cc
  $<TARGET_OBJECTS:common_texttable_obj>)
add_executable(ceph-dencoder ${dencoder_srcs})

set(denc_plugin_dir ${CEPH_INSTALL_PKGLIBDIR}/denc)
add_custom_target(ceph-dencoder-modules)

function(add_denc_mod name)
  add_library(${name} SHARED
    ${ARGN})
  set_target_properties(${name} PROPERTIES
    PREFIX ""
    OUTPUT_NAME ${name}
    CXX_VISIBILITY_PRESET hidden
    VISIBILITY_INLINES_HIDDEN ON)
  install(
    TARGETS ${name}
    DESTINATION ${denc_plugin_dir})
  add_dependencies(ceph-dencoder-modules
    ${name})
endfunction()

add_denc_mod(denc-mod-common
  common_types.cc)
target_link_libraries(denc-mod-common
  journal
  cls_cas_internal
  cls_lock_client
  cls_refcount_client
  cls_timeindex_client)
add_denc_mod(denc-mod-osd
  osd_types.cc)
target_link_libraries(denc-mod-osd
  os
  osd
  mon
  erasure_code)

if(WITH_RADOSGW)
  add_denc_mod(denc-mod-rgw
    rgw_types.cc
    ${CMAKE_SOURCE_DIR}/src/rgw/rgw_dencoder.cc)
  target_link_libraries(denc-mod-rgw
    rgw_a
    cls_rgw_client
    cls_journal_client)
  if(WITH_RADOSGW_AMQP_ENDPOINT)
    target_link_libraries(denc-mod-rgw
      rabbitmq ssl)
  endif()
  if(WITH_RADOSGW_KAFKA_ENDPOINT)
    target_link_libraries(denc-mod-rgw
      rdkafka)
  endif()
  if(WITH_RADOSGW_LUA_PACKAGES)
    target_link_libraries(denc-mod-rgw
      Boost::filesystem)
  endif()
endif()

if(WITH_RBD)
  add_denc_mod(denc-mod-rbd
    rbd_types.cc)
  target_link_libraries(denc-mod-rbd
    cls_rbd_client
    rbd_mirror_types
    rbd_types
    rbd_replay_types)
  if(WITH_KRBD)
    target_link_libraries(denc-mod-rbd
      krbd)
  endif()
endif()

if(WITH_CEPHFS)
  add_denc_mod(denc-mod-cephfs
    mds_types.cc)
  target_link_libraries(denc-mod-cephfs
    mds)
endif()

target_compile_definitions(ceph-dencoder PRIVATE
  "CEPH_DENC_MOD_DIR=\"${denc_plugin_dir}\"")

target_link_libraries(ceph-dencoder
  StdFilesystem::filesystem
  global
  ${DENCODER_EXTRALIBS}
  cls_log_client
  cls_version_client
  cls_user_client
  cls_cas_client
  ${ALLOC_LIBS}
  ${EXTRALIBS}
  ${CMAKE_DL_LIBS})
install(TARGETS ceph-dencoder DESTINATION bin)

=== src/spdk/lib/env_dpdk/Makefile ===
#
#  BSD LICENSE
#
#  Copyright (c) Intel Corporation.
#  All rights reserved.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
#  are met:
#
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above copyright
#      notice, this list of conditions and the following disclaimer in
#      the documentation and/or other materials provided with the
#      distribution.
#    * Neither the name of Intel Corporation nor the names of its
#      contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

SPDK_ROOT_DIR := $(abspath $(CURDIR)/../..)
include $(SPDK_ROOT_DIR)/mk/spdk.common.mk

SO_VER := 5
SO_MINOR := 0

CFLAGS += $(ENV_CFLAGS)
C_SRCS = env.c memory.c pci.c init.c threads.c
C_SRCS += pci_ioat.c pci_virtio.c pci_vmd.c pci_idxd.c
LIBNAME = env_dpdk

SPDK_MAP_FILE = $(abspath $(CURDIR)/spdk_env_dpdk.map)

include $(SPDK_ROOT_DIR)/mk/spdk.lib.mk

=== src/spdk/module/bdev/nvme/Makefile ===
#
#  BSD LICENSE
#
#  Copyright (c) Intel Corporation.
#  All rights reserved.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
#  are met:
#
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above copyright
#      notice, this list of conditions and the following disclaimer in
#      the documentation and/or other materials provided with the
#      distribution.
#    * Neither the name of Intel Corporation nor the names of its
#      contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

SPDK_ROOT_DIR := $(abspath $(CURDIR)/../../..)
include $(SPDK_ROOT_DIR)/mk/spdk.common.mk

SO_VER := 3
SO_MINOR := 0

C_SRCS = bdev_nvme.c bdev_nvme_rpc.c nvme_rpc.c common.c bdev_ocssd.c bdev_ocssd_rpc.c
C_SRCS-$(CONFIG_NVME_CUSE) += bdev_nvme_cuse_rpc.c

ifeq ($(OS),Linux)
C_SRCS += vbdev_opal.c vbdev_opal_rpc.c
endif
LIBNAME = bdev_nvme

SPDK_MAP_FILE = $(SPDK_ROOT_DIR)/mk/spdk_blank.map

include $(SPDK_ROOT_DIR)/mk/spdk.lib.mk

=== src/spdk/test/app/histogram_perf/Makefile ===
#
#  BSD LICENSE
#
#  Copyright (c) Intel Corporation.
#  All rights reserved.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
#  are met:
#
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above copyright
#      notice, this list of conditions and the following disclaimer in
#      the documentation and/or other materials provided with the
#      distribution.
#    * Neither the name of Intel Corporation nor the names of its
#      contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

SPDK_ROOT_DIR := $(abspath $(CURDIR)/../../..)
include $(SPDK_ROOT_DIR)/mk/spdk.common.mk

APP = histogram_perf

C_SRCS = histogram_perf.c

SPDK_LIB_LIST = thread util log

include $(SPDK_ROOT_DIR)/mk/spdk.app.mk

=== src/spdk/test/app/stub/Makefile ===
#
#  BSD LICENSE
#
#  Copyright (c) Intel Corporation.
#  All rights reserved.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
#  are met:
#
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above copyright
#      notice, this list of conditions and the following disclaimer in
#      the documentation and/or other materials provided with the
#      distribution.
#    * Neither the name of Intel Corporation nor the names of its
#      contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

SPDK_ROOT_DIR := $(abspath $(CURDIR)/../../..)
include $(SPDK_ROOT_DIR)/mk/spdk.common.mk
include $(SPDK_ROOT_DIR)/mk/spdk.modules.mk

APP = stub

C_SRCS := stub.c

SPDK_LIB_LIST = $(SOCK_MODULES_LIST)
SPDK_LIB_LIST += event conf nvme log trace rpc jsonrpc json thread util sock notify

ifeq ($(CONFIG_RDMA),y)
SPDK_LIB_LIST += rdma
endif

include $(SPDK_ROOT_DIR)/mk/spdk.app.mk

=== src/boost/libs/nowide/test/exampleProject/CMakeLists.txt ===
# Project testing to consume Boost.Nowide
cmake_minimum_required(VERSION 3.8.0)
project(nowide_example_project)

find_package(boost_nowide 10.0 REQUIRED)

add_executable(example example_main.cpp)
target_link_libraries(example PRIVATE Boost::nowide)
enable_testing()
add_test(NAME example COMMAND example)

=== src/seastar/dpdk/kernel/linux/igb_uio/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2010-2014 Intel Corporation

include $(RTE_SDK)/mk/rte.vars.mk

#
# module name and path
#
MODULE = igb_uio
MODULE_PATH = drivers/net/igb_uio

#
# CFLAGS
#
MODULE_CFLAGS += -I$(SRCDIR) --param max-inline-insns-single=100
MODULE_CFLAGS += -I$(RTE_OUTPUT)/include
MODULE_CFLAGS += -Winline -Wall -Werror
MODULE_CFLAGS += -include $(RTE_OUTPUT)/include/rte_config.h

#
# all source are stored in SRCS-y
#
SRCS-y := igb_uio.c

include $(RTE_SDK)/mk/rte.module.mk

=== src/spdk/test/unit/lib/bdev/mt/Makefile ===
#
#  BSD LICENSE
#
#  Copyright (c) Intel Corporation.
#  All rights reserved.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
#  are met:
#
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above copyright
#      notice, this list of conditions and the following disclaimer in
#      the documentation and/or other materials provided with the
#      distribution.
#    * Neither the name of Intel Corporation nor the names of its
#      contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

SPDK_ROOT_DIR := $(abspath $(CURDIR)/../../../../..)
include $(SPDK_ROOT_DIR)/mk/spdk.common.mk

DIRS-y = bdev.c

.PHONY: all clean $(DIRS-y)

all: $(DIRS-y)
clean: $(DIRS-y)

include $(SPDK_ROOT_DIR)/mk/spdk.subdirs.mk

=== src/spdk/test/unit/lib/sock/posix.c/Makefile ===
#
#  BSD LICENSE
#
#  Copyright (c) Intel Corporation.
#  All rights reserved.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
#  are met:
#
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above copyright
#      notice, this list of conditions and the following disclaimer in
#      the documentation and/or other materials provided with the
#      distribution.
#    * Neither the name of Intel Corporation nor the names of its
#      contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

SPDK_ROOT_DIR := $(abspath $(CURDIR)/../../../../..)

TEST_FILE = posix_ut.c

include $(SPDK_ROOT_DIR)/mk/spdk.unittest.mk

=== debian/changelog ===
ceph (16.2.15-0ubuntu0.21.04.1~cloud1) focal-wallaby; urgency=medium

  * d/control: Add versioned Breaks/Replaces to ceph-base deal with move of
    smartctl sudoers from from the ceph-osd package (LP: #2068109).

 -- James Page <james.page@ubuntu.com>  Wed, 07 Aug 2024 16:57:15 +0100

ceph (16.2.15-0ubuntu0.21.04.1~cloud0) focal-wallaby; urgency=medium

  * New upstream release (LP: #2057713):
    - d/p/*: Refresh.
    - d/p/bug1917414.patch: Drop, included in release.

 -- Luciano Lo Giudice <luciano.logiudice@canonical.com>  Wed, 10 Apr 2024 14:21:14 +0100

ceph (16.2.14-0ubuntu0.21.04.1~cloud0) focal-wallaby; urgency=medium

  * New upstream point release (LP: #2034076).

 -- Luciano Lo Giudice <luciano.logiudice@canonical.com>  Thu, 21 Sep 2023 14:55:37 +0100

ceph (16.2.13-0ubuntu0.21.04.1~cloud1) focal-wallaby; urgency=medium

   * Ensure Ceph is linked with and uses tcmalloc, resolving significant
     performance and memory footprint regresssions LP: #2016845):
    - d/p/bug2016845-*.patch: Cherry pick fixes to build system to re-
      enable use of tcmalloc.

 -- James Page <james.page@ubuntu.com>  Thu, 20 Jul 2023 11:52:18 +0100

ceph (16.2.13-0ubuntu0.21.04.1~cloud0) focal-wallaby; urgency=medium

  * New upstream point release (LP: #2023321):
    - d/p/32bit-fixes.patch: Refresh.

 -- Luciano Lo Giudice <luciano.logiudice@canonical.com>  Fri, 23 Jun 2023 16:08:35 +0000

ceph (16.2.11-0ubuntu0.21.04.1~cloud0) focal; urgency=medium

  [ Chris MacNaughton ]
  * New upstream point release (LP: #2009513).

  [ James Page ]
  * d/p/python-dist-packages.patch: Tweak changes to CMake configuration
    to ensure that Python modules always get installed to dist-packages.

 -- Chris MacNaughton <chris.macnaughton@ubuntu.com>  Tue, 07 Mar 2023 13:21:29 +0000

ceph (16.2.9-0ubuntu0.21.04.1~cloud0) focal; urgency=medium

  * New upstream release (LP: #1975906).
  * d/p/disable-log-slow-requests.patch: Drop, ceph now aggregates slow
    request reporting.

 -- James Page <james.page@ubuntu.com>  Mon, 06 Jun 2022 09:55:06 +0100

ceph (16.2.7-0ubuntu0.21.04.1~cloud2) focal; urgency=medium

  * New upstream release (LP: #1953599).
  * d/control,ceph-{osd,base}.install,rules: Update name of smartctl
    sudoers file and move to ceph-base package to allow use from both
    mon and osd services.
  * d/*: Fold in UCA backport patch as new uploads with target the
    Wallaby UCA directly.

 -- James Page <james.page@ubuntu.com>  Tue, 18 Jan 2022 13:48:17 +0000

ceph (16.2.6-0ubuntu0.21.04.1) hirsute; urgency=medium

  [ Frode Nordahl ]
  * d/control: The ISA-L EC plugin changed its build dependency from yasm to
    nasm 2.13.03 or newer (LP: #1940697)

  [ James Page ]
  * New upstream point release (LP: #1943932).

 -- James Page <james.page@ubuntu.com>  Sun, 19 Sep 2021 09:29:10 +0100

ceph (16.2.5-0ubuntu0.21.04.1) hirsute; urgency=medium

  * New upstream point release (LP: #1935817).

 -- James Page <james.page@ubuntu.com>  Tue, 20 Jul 2021 12:20:02 +0100

ceph (16.2.4-0ubuntu0.21.04.1) hirsute; urgency=medium

  [ Chris MacNaughton ]
  * d/ceph-base.install: Remove ceph-deploy man page installation
    (LP: #1892448).

  [ James Page ]
  * SECURITY UPDATE: New upstream release (LP: #1928645):
    - CVE-2021-3509: Dashboard XSS via token cookie.
    - CVE-2021-3531: Swift API denial of service.
    - CVE-2021-3531: HTTP header injects via CORS in RGW.
    - d/p/bug1925347.patch: Drop, included in release.

 -- James Page <james.page@ubuntu.com>  Thu, 27 May 2021 06:18:16 +0100

ceph (16.2.1-0ubuntu0.21.04.1) hirsute-proposed; urgency=medium

  * SECURITY UPDATE: New upstream point release (LP: #1925322):
    - CVE-2021-20288
  * d/rules: remove temporary build objects after install to avoid
    running out of disk space during package builds.
  * d/p/bug1925347.patch: Cherry pick fix to revert ProtectClock
    permissions change in systemd configurations which prevents the
    ceph-osd process from starting (LP: #1925347).

 -- James Page <james.page@ubuntu.com>  Thu, 22 Apr 2021 10:21:35 +0100

=== debian/control ===
Source: ceph
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Ceph Packaging Team <team+ceph@tracker.debian.org>
Uploaders:
 James Page <jamespage@debian.org>,
 Gaudenz Steinlin <gaudenz@debian.org>,
 Bernd Zeimetz <bzed@debian.org>,
Homepage: http://ceph.com/
Vcs-Git: https://salsa.debian.org/ceph-team/ceph.git
Vcs-Browser: https://salsa.debian.org/ceph-team/ceph
Build-Depends:
 clang [armhf mipsel armel m68k sh4],
 cmake,
 cython3,
 debhelper (>= 10~),
 default-jdk,
 dh-exec,
 dh-python,
 dpkg-dev (>= 1.16.1~),
 gperf,
 javahelper,
 junit4,
 libaio-dev,
 libbabeltrace-ctf-dev,
 libbabeltrace-dev,
 libblkid-dev (>= 2.17),
 libbz2-dev,
 libcap-ng-dev,
 libcryptsetup-dev,
 libcunit1-dev,
 libcurl4-gnutls-dev,
 libedit-dev,
 libexpat1-dev,
 libfuse-dev,
 libgoogle-perftools-dev [i386 amd64 powerpc armhf arm64 ppc64el],
 libibverbs-dev,
 libicu-dev,
 libkeyutils-dev,
 libldap2-dev,
 libleveldb-dev,
 liblua5.3-dev,
 liblz4-dev (>= 0.0~r131),
 libncurses-dev,
 libnl-3-dev,
 libnl-genl-3-dev,
 libnss3-dev,
 liboath-dev,
 libpmem-dev [amd64 arm64 ppc64el],
 libpmemobj-dev [amd64 arm64 ppc64el],
 librabbitmq-dev,
 librdmacm-dev,
 libsnappy-dev,
 libsqlite3-dev,
 libssl-dev,
 libtool,
 libudev-dev,
 libxml2-dev,
 lsb-release,
 luarocks,
 nasm (>= 2.13.03) [amd64],
 pkg-config,
 python3-cherrypy3,
 python3-dev,
 python3-pecan,
 python3-setuptools,
 python3-sphinx,
 tox,
 uuid-runtime,
 valgrind [amd64 armhf i386 powerpc],
 virtualenv,
 xfslibs-dev,
 zlib1g-dev,
Build-Conflicts:
 libcrypto++-dev,
Standards-Version: 4.2.1

Package: ceph
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 ceph-mgr (= ${binary:Version}),
 ceph-mon (= ${binary:Version}),
 ceph-osd (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 ceph-mds (= ${binary:Version}),
Description: distributed storage and file system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.

Package: ceph-base
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 binutils,
 ceph-common (= ${binary:Version}),
 cryptsetup-bin | cryptsetup,
 gdisk,
 hdparm | sdparm,
 parted,
 uuid-runtime,
 xfsprogs,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Recommends:
 ceph-mds (= ${binary:Version}),
 chrony | time-daemon | ntp,
 librados2 (= ${binary:Version}),
 librbd1 (= ${binary:Version}),
 nvme-cli,
 smartmontools (>= 7.0),
Suggests:
 btrfs-tools,
 logrotate,
Breaks:
 ceph-osd (<< 16.2.7-0ubuntu0.21.04.1~cloud2~),
Replaces:
 ceph-osd (<< 16.2.7-0ubuntu0.21.04.1~cloud2~),
Description: common ceph daemon libraries and management tools
 Ceph is a distributed storage system designed to provide excellent
 performance, reliability, and scalability.
 .
 This package contains the libraries and management tools that are common among
 the Ceph server daemons (ceph-mon, ceph-mgr, ceph-osd, ceph-mds). These tools
 are necessary for creating, running, and administering a Ceph storage cluster.

Package: ceph-common
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 librbd1 (= ${binary:Version}),
 python3-ceph-argparse (= ${binary:Version}),
 python3-ceph-common (= ${binary:Version}),
 python3-cephfs (= ${binary:Version}),
 python3-prettytable,
 python3-rados (= ${binary:Version}),
 python3-rbd (= ${binary:Version}),
 python3-requests,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Conflicts:
 ceph-client-tools,
Breaks:
 ceph-mds (<< 14.2.5-3~),
Replaces:
 ceph-mds (<< 14.2.5-3~),
Suggests:
 ceph,
 ceph-mds,
Description: common utilities to mount and interact with a ceph storage cluster
 Ceph is a distributed storage and file system designed to provide
 excellent performance, reliability, and scalability.  This is a collection
 of common tools that allow one to interact with and administer a Ceph cluster.

Package: ceph-fuse
Architecture: amd64
Depends:
 python3,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends:
 fuse,
Description: FUSE-based client for the Ceph distributed file system
 Ceph is a distributed network file system designed to provide
 excellent performance, reliability, and scalability.  This is a
 FUSE-based client that allows one to mount a Ceph file system without
 root privileges.
 .
 Because the FUSE-based client has certain inherent performance
 limitations, it is recommended that the native Linux kernel client
 be used if possible.  If it is not practical to load a kernel module
 (insufficient privileges, older kernel, etc.), then the FUSE client will
 do.

Package: ceph-immutable-object-cache
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 librados2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Ceph daemon for immutable object cache
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.  This is a daemon for immutable
 object cache.

Package: ceph-mds
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 ceph-base (= ${binary:Version}),
 librados2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 libcephfs2 (= ${binary:Version}),
Suggests:
 ceph-fuse,
Breaks:
 ceph (<< 0.67.3-1),
Replaces:
 ceph (<< 0.67.3-1),
Description: metadata server for the ceph distributed file system
 Ceph is a distributed storage and network file system designed to
 provide excellent performance, reliability, and scalability.
 .
 This package contains the metadata server daemon, which is used to
 create a distributed file system on top of the ceph storage cluster.

Package: ceph-mgr
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 ceph-base (= ${binary:Version}),
 ceph-mgr-modules-core (= ${binary:Version}),
 libsqlite3-mod-ceph (= ${binary:Version}),
 python3-bcrypt,
 python3-cherrypy3,
 python3-jwt,
 python3-pecan,
 python3-werkzeug,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Replaces:
 ceph (<< 0.93-417),
Breaks:
 ceph (<< 0.93-417),
Suggests:
 ceph-mgr-cephadm,
 ceph-mgr-dashboard,
 ceph-mgr-diskprediction-local,
 ceph-mgr-k8sevents,
Description: manager for the ceph distributed file system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the manager daemon, which is used to expose high
 level management and monitoring functionality.

Package: ceph-mgr-cephadm
Architecture: all
Depends:
 ceph-mgr (= ${binary:Version}),
 cephadm,
 openssh-client,
 python3-jinja2,
 ${misc:Depends},
 ${python:Depends},
Description: cephadm orchestrator module for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the CEPHADM module for ceph-mgr's orchestration
 functionality, to allow ceph-mgr to perform orchestration functions
 over a standard SSH connection.

Package: ceph-mgr-dashboard
Architecture: all
Depends:
 ceph-mgr (>= ${binary:Version}),
 python3-bcrypt,
 python3-cherrypy3,
 python3-distutils,
 python3-jwt,
 python3-openssl,
 python3-routes,
 python3-werkzeug,
 python3-yaml,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: dashboard module for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package provides a ceph-mgr module, providing a web-based
 application to monitor and manage many aspects of a Ceph cluster and
 related components.
 .
 See the Dashboard documentation at http://docs.ceph.com/ for details
 and a detailed feature overview.

Package: ceph-mgr-diskprediction-local
Architecture: all
Depends:
 ceph-mgr (>= ${binary:Version}),
 python3-numpy,
 python3-scipy,
 python3-sklearn,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: diskprediction-local module for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the diskprediction_local module for the ceph-mgr
 daemon, which helps predict disk failures.

Package: ceph-mgr-k8sevents
Architecture: all
Depends:
 ceph-mgr (>= ${binary:Version}),
 python3-kubernetes,
 ${misc:Depends},
 ${python:Depends},
Description: kubernetes events module for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the k8sevents module, to allow ceph-mgr to send
 ceph related events to the kubernetes events API, and track all events
 that occur within the rook-ceph namespace.

Package: ceph-mgr-modules-core
Architecture: all
Depends:
 python3-dateutil,
 python3-openssl,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Suggests:
 ceph-mgr-rook,
Replaces:
 ceph-mgr (<< 15.1.1-0ubuntu1~),
Breaks:
 ceph-mgr (<< 15.1.1-0ubuntu1~),
Description: ceph manager modules which are always enabled
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains a set of core ceph-mgr modules which are always
 enabled.

Package: ceph-mgr-rook
Architecture: all
Depends:
 ceph-mgr (>= ${binary:Version}),
 python3-jsonpatch,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: rook module for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the rook module for ceph-mgr's orchestration
 functionality, to allow ceph-mgr to install and configure ceph using
 Rook.

Package: ceph-mon
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 ceph-base (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Replaces:
 ceph (<< 10.2.2-0ubuntu2~),
Breaks:
 ceph (<< 10.2.2-0ubuntu2~),
Description: monitor server for the ceph storage system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the cluster monitor daemon for the Ceph storage
 system. One or more instances of ceph-mon form a Paxos part-time parliament
 cluster that provides extremely reliable and durable storage of cluster
 membership, configuration, and state.

Package: ceph-osd
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 ceph-base (= ${binary:Version}),
 lvm2,
 sudo,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ceph-common (= ${binary:Version}),
Replaces:
 ceph (<< 10.2.2-0ubuntu2~),
 ceph-test (<< 12.2.8+dfsg1-1~),
Breaks:
 ceph (<< 10.2.2-0ubuntu2~),
 ceph-test (<< 12.2.8+dfsg1-1~),
Description: OSD server for the ceph storage system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1

DEB_HOST_ARCH_BITS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)
export DEB_BUILD_ARCH      ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
export DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# support ccache for faster build
# cmake uses /usr/bin/c*
ifeq (yes,$(findstring yes,$(shell test -L /usr/lib/ccache/c++ && test -L /usr/lib/ccache/cc && echo -n yes)))
  extraopts += -DWITH_CCACHE=ON
endif

# Don't switch to clang for Ubuntu - armhf builder is
# just fine using g++
ifeq ($(shell dpkg-vendor --is Debian && echo yes), yes)
# try to save even more memory on some architectures
# see #849657 for hints.
ifneq (,$(findstring $(DEB_HOST_ARCH),armhf mipsel armel sh4 m68k))
  export CC=clang
  export CXX=clang++
  extraopts += -DCMAKE_CXX_COMPILER=/usr/bin/clang++
  extraopts += -DCMAKE_C_COMPILER=/usr/bin/clang
else
    # Reduce size of debug symbols to fix FTBFS due to the
    # 2GB/3GB address space limits on 32bit
    ifeq (32,$(DEB_HOST_ARCH_BITS))
        export DEB_CFLAGS_MAINT_APPEND = -g1
        export DEB_CXXFLAGS_MAINT_APPEND = -g1
    endif
endif
else
    # Reduce size of debug symbols to fix FTBFS due to the
    # 2GB/3GB address space limits on 32bit
    ifeq (32,$(DEB_HOST_ARCH_BITS))
        export DEB_CFLAGS_MAINT_APPEND = -g1
        export DEB_CXXFLAGS_MAINT_APPEND = -g1
    endif
endif # dpkg-vendor --is Debian

ifeq ($(shell dpkg-vendor --is Ubuntu && echo yes) $(DEB_HOST_ARCH), yes i386)
   skip_packages = -Nceph -Nceph-base -Nceph-mds -Nceph-mgr -Nceph-mon -Nceph-osd -Nceph-common -Nradosgw -Nrbd-mirror
endif

# minimise needless linking and link to libatomic
# The last is needed because long long atomic operations are not directly
# supported by all processor architectures
export DEB_LDFLAGS_MAINT_APPEND= -Wl,--as-needed -latomic

# Enable hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto

export DESTDIR=$(CURDIR)/debian/tmp

export JAVA_HOME=/usr/lib/jvm/default-java
## Set JAVAC to prevent FTBFS due to incorrect use of 'gcj' if found (see "m4/ac_prog_javac.m4").
export JAVAC=javac

extraopts += -DWITH_OCF=ON -DWITH_NSS=ON -DWITH_PYTHON3=ON -DWITH_DEBUG=ON
extraopts += -DWITH_PYTHON2=OFF -DMGR_PYTHON_VERSION=3
extraopts += -DWITH_PYTHON3=3
extraopts += -DWITH_CEPHFS_JAVA=ON
extraopts += -DWITH_CEPHFS_SHELL=ON
extraopts += -DWITH_TESTS=OFF
extraopts += -DWITH_SYSTEM_BOOST=OFF
extraopts += -DWITH_LTTNG=OFF -DWITH_EMBEDDED=OFF
extraopts += -DCMAKE_INSTALL_LIBEXECDIR=/usr/lib
extraopts += -DWITH_MGR_DASHBOARD_FRONTEND=OFF
extraopts += -DWITH_SYSTEMD=ON -DCEPH_SYSTEMD_ENV_DIR=/etc/default
extraopts += -DCMAKE_INSTALL_SYSCONFDIR=/etc
extraopts += -DCMAKE_INSTALL_SYSTEMD_SERVICEDIR=/lib/systemd/system
extraopts += -DWITH_RADOSGW_KAFKA_ENDPOINT=OFF
extraopts += -DCMAKE_BUILD_TYPE=RelWithDebInfo
extraopts += -DWITH_GRAFANA=ON

ifneq (,$(findstring $(DEB_HOST_ARCH),amd64 arm64 ppc64el))
extraopts += -DWITH_RBD_RWL=ON
extraopts += -DWITH_RBD_SSD_CACHE=ON
extraopts += -DWITH_SYSTEM_PMDK=ON
extraopts += -DWITH_BLUESTORE_PMEM=ON
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  extraopts += -DBOOST_J=$(NUMJOBS)
endif

ifneq (,$(findstring $(DEB_HOST_ARCH),mips64el ia64 m68k ppc64 sh4 sparc64 x32))
  # beast depends on libboost_{context,coroutine} which is not supported on various archs
  extraopts += -DWITH_BOOST_CONTEXT=OFF
else
  extraopts += -DWITH_BOOST_CONTEXT=ON
endif

# Disable SPDK as it generates a build which is no compatible
# with older CPU's which are still supported by Ubuntu.
extraopts += -DWITH_SPDK=OFF

MAX_PARALLEL ?= $(shell ./debian/calc-max-parallel.sh)

%:
	dh $@ --buildsystem=cmake --with javahelper,python3,systemd $(MAX_PARALLEL)

override_dh_auto_configure:
	env | sort
	dh_auto_configure --buildsystem=cmake -- $(extraopts)
# after trying to patch the various places where HAVE_ARM_NEON is used
# the easiest way to get rid of it on armel seems to be to patch the cmake
# cache file.
ifeq ($(DEB_HOST_ARCH),armel)
	sed 's,^HAVE_ARM_NEON.*,HAVE_ARM_NEON:INTERNAL=0,' -i obj-arm-linux-gnueabi/CMakeCache.txt
endif

override_dh_auto_install:
	dh_auto_install --buildsystem=cmake --destdir=$(DESTDIR)
	install -D -m 644 udev/50-rbd.rules $(DESTDIR)/lib/udev/rules.d/50-rbd.rules
	install -D -m 644 src/etc-rbdmap $(DESTDIR)/etc/ceph/rbdmap
	install -D -m 644 etc/sysctl/90-ceph-osd.conf $(DESTDIR)/etc/sysctl.d/30-ceph-osd.conf
	install -D -m 600 sudoers.d/ceph-smartctl $(DESTDIR)/etc/sudoers.d/ceph-smartctl

	install -m 755 src/cephadm/cephadm $(DESTDIR)/usr/sbin/cephadm

	# NOTE: ensure that any versioned erasure coding test code is dropped
	#       from the package install - package ships unversioned modules.
	rm -f $(CURDIR)/debian/tmp/usr/lib/*/ceph/erasure-code/libec_*.so.*
	find $(CURDIR)/debian/tmp/usr/lib/*/ceph/erasure-code -type l -delete || :
	# avoid running out of disk space
	rm -rf $(CURDIR)/obj-*-linux-gnu


# doc/changelog is a directory, which confuses dh_installchangelogs
override_dh_installchangelogs:
	dh_installchangelogs --exclude doc/changelog

override_dh_installlogrotate:
	cp src/logrotate.conf debian/ceph-common.logrotate
	dh_installlogrotate -pceph-common


override_dh_installinit:
	cp src/init-radosgw debian/radosgw.init
	dh_installinit --no-start
	dh_installinit -pceph-common --name=rbdmap --no-start
	dh_installinit -pceph-base --name ceph --no-start
	# install the systemd stuff manually since we have funny service names
	# and need to update the paths in all of the files post install
	# systemd:ceph-common
	install -d -m0755 debian/ceph-common/usr/lib/tmpfiles.d
	install -m 0644 -D systemd/ceph.tmpfiles.d debian/ceph-common/usr/lib/tmpfiles.d/ceph.conf
	# NOTE(jamespage): Install previous ceph-mon service from packaging for upgrades
	install -d -m0755 debian/ceph-mon/lib/systemd/system
	install -m0644 debian/lib-systemd/system/ceph-mon.service debian/ceph-mon/lib/systemd/system
	# Ensure Debian/Ubuntu specific systemd units are NOT automatically enabled and started
	# Enable systemd targets only
	dh_systemd_enable -Xceph-mon.service -Xceph-osd.service -X ceph-mds.service
	# Start systemd targets only
	dh_systemd_start --no-stop-on-upgrade --no-restart-after-upgrade

override_dh_systemd_enable:
	# systemd enable done as part of dh_installinit

override_dh_systemd_start:
	# systemd start done as part of dh_installinit

override_dh_makeshlibs:
	# exclude jni libraries in libcephfs-jni to avoid pointless ldconfig
	# calls in maintainer scripts; exclude private erasure-code plugins.
	dh_makeshlibs -V -X/usr/lib/jni -X/usr/lib/$(DEB_HOST_MULTIARCH)/ceph/erasure-code

override_dh_auto_test:
	# do not run tests

override_dh_shlibdeps:
	dh_shlibdeps -a --exclude=erasure-code --exclude=rados-classes --exclude=compressor

override_dh_python3:
	for binding in rados cephfs rbd rgw; do \
		dh_python3 -p python3-$$binding --shebang=/usr/bin/python3;      \
        done
	dh_python3 -p python3-ceph-argparse --shebang=/usr/bin/python3
	dh_python3 -p python3-ceph-common --shebang=/usr/bin/python3
	dh_python3 -p ceph-common --shebang=/usr/bin/python3
	dh_python3 -p ceph-base --shebang=/usr/bin/python3
	dh_python3 -p ceph-osd --shebang=/usr/bin/python3
	dh_python3 -p ceph-mgr --shebang=/usr/bin/python3
	dh_python3 -p cephfs-shell --shebang=/usr/bin/python3
	dh_python3 -p cephadm --shebang=/usr/bin/python3

override_dh_builddeb:
	dh_builddeb ${skip_packages}

override_dh_gencontrol:
	dh_gencontrol ${skip_packages}
